let
  nixpkgs = fetchTarball "https://github.com/NixOS/nixpkgs/tarball/nixos-23.05";
  pkgs = import nixpkgs { config = {}; overlays = []; };
in
  derivation {
    name = "hello";
    builder = "${pkgs.bash}/bin/bash";
    args = [ ./hello_builder.sh ];
    inherit (pkgs) gnutar gzip gnumake gcc coreutils gawk gnused gnugrep;
    bintools = pkgs.binutils.bintools;
    src = pkgs.fetchzip {
      url = "https://ftp.gnu.org/gnu/hello/hello-2.12.1.tar.gz";
      sha256 = "sha256-1kJjhtlsAkpNB7f6tZEs+dbKd8z7KoNHyDHEJ0tmhnc=";
    };
    system = builtins.currentSystem;
  }