{
  pkgs ? import <nixpkgs> {}
, helmnix ? import ./nix/helm.nix {}
, lib ? pkgs.lib
}:
let
  charts = [
    rec {
      name = "kube-prometheus-stack";
      version = "57.0.3";
      url = "https://github.com/prometheus-community/helm-charts/releases/download/${name}-${version}/${name}-${version}.tgz";
      hash = "sha256-oZNaFSfFR2dtf5IMUQ0CnXQeVLvoW22JdRqMmgmdtTs=";
      patches = [
        ./patches/kube-prometheus-stack.patch
      ];
    }
    rec {
      name = "cert-manager";
      version = "v1.14.4";
      url = "https://charts.jetstack.io/charts/${name}-${version}.tgz";
      hash = "sha256-V3X9vBiB1uUQ33bTh1OvVLhr0Uyqjtso/bt5UnBC3t4=";
    }
  ];

  packages = builtins.map (chart: helmnix.mkHelm chart) charts;
in
  packages

